#!/usr/bin/php
<?php
/*
 * 4 = value
 * 7 = Raw 
 * 
 * include this into the /etc/sudoers file!!
 * www-data    ALL= NOPASSWD: /usr/sbin/smartctl
 * 
 */

if ($argc < 2) {
	die("USAGE: $argv[0] /dev/hdX\n");
}


$dev = $argv[1];
$smartCtl = exec('sudo smartctl --all ' . $dev,$output);
//print_r($output);
$_OUT = array();
$needle = "Temperature_Celsius,Reallocated_Sector_Ct,Power_On_Hours,Spin_Retry_Count,Seek_Error_Rate,Raw_Read_Error_Rate";


foreach ($output as $line) {
	if (preg_match('/^\s*(\d+)\s+(\w+)\s+(0x[0-9a-fA-F]+)\s+(\d+)\s+(\d+)\s+(\d+).*\s+\-\s+(\d+)/',$line,$match)) {
	//	print_r($match);
		if ( $match[2] == 'Temperature_Celsius') $_OUT['Temperature_Celsius'] = $match[7];
		if ( $match[2] == 'Reallocated_Sector_Ct') $_OUT['Reallocated_Sector_Ct'] = $match[7];
		if ( $match[2] == 'Power_On_Hours') $_OUT['Power_On_Hours'] = $match[7];
		if ( $match[2] == 'Spin_Retry_Count') $_OUT['Spin_Retry_Count'] = $match[7];
		if ( $match[2] == 'Seek_Error_Rate') $_OUT['Seek_Error_Rate'] = $match[7];	
		if ( $match[2] == 'Raw_Read_Error_Rate') $_OUT['Raw_Read_Error_Rate'] = $match[7];
	}
}


$needle = explode(",",$needle);
foreach ( $needle as $need ) {
	if ( ! isset($_OUT[$need]) ) $_OUT[$need] = 0;
}


print (
	"Temperature_Celsius:" . $_OUT['Temperature_Celsius'] . " " .
	"Reallocated_Sector_Ct:" . $_OUT['Reallocated_Sector_Ct'] . " " .
	"Power_On_Hours:" . $_OUT['Power_On_Hours'] . " " .
	"Spin_Retry_Count:" . $_OUT['Spin_Retry_Count'] . " " .
	"Seek_Error_Rate:" . $_OUT['Seek_Error_Rate'] . " " .
	"Raw_Read_Error_Rate:" . $_OUT['Raw_Read_Error_Rate']
);


?>
